#!/usr/bin/perl
# Generated automatically from detwit.pl.in by configure.

use lib '/usr/share/news-peruser';
use Peruser;

# Removes articles authored by twits from spool files.

sub by_position
{
   return $a->[ 3 ] <=> $b->[ 3 ];
}

sub advance
{
   my $copy = shift;
   my $line;

   if ( $copy == 0 || $copy == 1 )
   {
      do
      {
         $line = <SPOOL>;
         if ( $copy == 1 )
         {
            print TEMP $line;
         }
      }
      while( $line ne ".\r\n" );
   }
   elsif( $copy == 2 || $copy == 3 )
   {
      $line = <READ>;
      if( $copy == 3 )
      {
         print TEMP_READ $line;
      }
   }
}

sub fix_files
{
   while( not eof SPOOL )
   {
      advance( 1 );
      advance( 3 );
   }

   safe_close( \*SPOOL );
   safe_close( \*TEMP );
   rename "$spool:tmp", "$spool";

   safe_close( \*READ );
   safe_close( \*TEMP_READ );
   rename "$spool:read:tmp", "$spool:read";
}

$twits = "$home/.peruser4-twits";

if ( not -e $twits )
{
   feedback( "No twits on file." ) if ( $#ARGV == -1 );
   exit 0;
}

unless ( safe_open( \*TWITS, $twits ))
{
   feedback( "Could not open $twits: $!\n" ) if ( $#ARGV == -1 );
   exit 1;
}

while( <TWITS> )
{
   chop;
   push @twits, $_;
}

safe_close( \*TWITS );

@servers = get_servers();
exit( 0 ) if ( $#servers < 0 );

foreach $server ( @servers )
{
   next if ( $server eq 'Folders' );
   @groups = get_groups( $server );
   next if ( $#groups < 0 );

   foreach $group ( @groups )
   {
      $count = 0;
      next unless( safe_open( \*SPOOL, "$spooldir/$server-$group" ));

      while( <SPOOL> )
      {
         if ( $_ eq "\r\n" )
         {
            advance( 0 );
            ++$count;
         }

         if ( $_ eq ".\r\n" )
         {
            ++$count;
            next;
         }

         if ( /From: +(.+)/ || /Author: +(.+)/ )
         {
            push @list, [ $1, $server, $group, $count, 0 ];
            advance( 0 );
            ++$count;
         }
      }

      safe_close( \*SPOOL );
   }
}

if ( $#list < 0 )
{
   feedback( "No articles in database." ) if ( $#ARGV == -1 );
   exit 0;
}

foreach $item ( @list )
{
   foreach $twit ( @twits )
   {
      if ( $item->[ 0 ] =~ $twit )
      {
         push @dups, $item;
      }
   }
}

if( $#dups < 0 )
{
   feedback( "No twit-authored messages found." ) if ( $#ARGV == -1 );
   exit 0;
}

@list = ();

foreach $server ( @servers )
{
   next if ( $server eq 'Folders' );
   @groups = get_groups( $server );
   next if( $#groups < 0 );

   foreach $group ( @groups )
   {
      @temp = ();

      foreach $item ( @dups )
      {
         if ( $item->[ 1 ] eq $server && $item->[ 2 ] eq $group )
         {
            push @temp, $item;
         }
      }

      next if ( $#temp < 0 );

      @temp = sort by_position @temp;
      push @list, ( @temp );
   }
}

@temp = ();
@dups = ();
$quantity = 0;

$server = $group = undef;

foreach $item ( @list )
{
   if( $item->[ 1 ] ne $server || $item->[ 2 ] ne $group )
   {
      if( defined $server )
      {
         fix_files();
         push @dups, [ $server, $group, $quantity ];
         $total += $quantity;
      }

      $server = $item->[ 1 ];
      $group = $item->[ 2 ];
      $spool = "$spooldir/$server-$group";

      $count = 0;
      $quantity = 0;

      die unless( safe_open( \*SPOOL, "$spool" ));
      die unless( safe_open( \*TEMP, ">$spool:tmp" ));
      die unless( safe_open( \*READ, "$spool:read" ));
      die unless( safe_open( \*TEMP_READ, ">$spool:read:tmp" ));
   }

   ++$quantity;
   $position = $item->[ 3 ] - $count;
   die if ( $position < 0 );

   while( $position-- )
   {
      advance( 1 );
      advance( 3 );
      ++$count;
   }

   advance( 0 );
   advance( 2 );
   ++$dups;
   ++$count;
}

fix_files();
push @dups, [ $server, $group, $quantity ];
$total += $quantity;

$reply = "$total twit-authored articles removed from database:\n\n";

foreach $item ( @dups )
{
   $reply .= "$item->[ 0 ]: $item->[ 1 ]: $item->[ 2 ]\n";
}

feedback( $reply ) if ( $#ARGV == -1 );
0;
