#!/usr/bin/perl
# Generated automatically from rm_filter.pl.in by configure.

use lib '/usr/share/news-peruser';
use Peruser;

# Allows user to remove an entry from ~/.peruser4-filters

unless ( safe_open( \*FILTERS, "$home/.peruser4-filters" ))
{
   feedback( "No filters exist." );
   exit( 0 );
}

$filters = "REGULAR EXPRESSION FILTERS:\\n\\n";

while( <FILTERS> )
{
   s/\\:/&/g;

   @lines = split /:/;
   $lines[ 0 ] =~ s/&/:/g;
   $lines[ 1 ] =~ s/&/:/g;

   $count++;

   $filters .= "$count: $lines[ 0 ] is bound to $lines[ 1 ]\\n";
}

safe_close( \*FILTERS );

$query = "'$filters\\nEnter the number of a filter\\nyou would like" .
         " to dissociate from its folder.'";
$filter = `npgettext $query`;

exit( 0 ) if ( $filter eq '(cancelled)' );

if ( not $filter =~ /^[1-9]+[0-9]*$/ )
{
   feedback( "Value input was not a number\n" );
   exit( 1 );
}

if ( $filter < 1 || $filter > $count )
{
   feedback( "Filter index out of range\n" );
   exit( 1 );
}

$path = "$home/.peruser4-filters";
$tmp = "$path:tmp";

exit( 1 ) unless( safe_open( \*FILTERS, $path ));
exit( 1 ) unless( safe_open( \*TEMP, ">$tmp" ));

$count = 0;

my $pattern;

while( <FILTERS> )
{
   if ( ++$count == $filter )
   {
      $pattern = $_;
      next;
   }

   print TEMP $_;
}

safe_close( \*TEMP );
safe_close( \*FILTERS );

rename( $tmp, $path );

feedback( "$pattern has been removed from the list" );

exit( 0 );
