#!/usr/bin/perl
# Generated automatically from search.pl.in by configure.

use lib '/usr/share/news-peruser';
use Peruser;

unless( safe_open( \*FILE, "$home/.npsummary:pid" ))
{
   feedback( "The summary applet must be running and loaded with " .
             "a newsgroup.\n" );
   exit 1;
}

$pid = <FILE>;

safe_close( \*FILE );

unless( kill( 'USR1', $pid ))
{
   feedback( "kill SIGUSR2 $pid failed: $!\n" );
   exit 1;
}

$file = "$spooldir/.current_group";
sleep 1;

unless( safe_open( \*FILE, "$file" ))
{
   feedback( "Could not open $file: $!\n" );
   exit 1;
}

$server = <FILE>;
chop $server;
$group = <FILE>;
chop $group;

safe_close( \*FILE );

$cancelled = '(cancelled)';
$query = 'Enter a WILDMAT pattern to scan for: ';
$search_text = `npgettext '$query'`;
exit( 0 ) if ( $search_text eq $cancelled );

unless( open_server( $server ))
{
   feedback( "Could not connect to $server\n" );
   exit 1;
}

%results = xpat( $group, "Subject", $search_text );

if ( not defined %results )
{
   disconnect();
   feedback( "No matches." );
   exit 0;
}

foreach $key ( keys %results )
{
   ++$matches;
}

$query = "$matches matches found. Download?";
$response = `npyesno '$query'`;
if ( $response eq 'no' )
{
   disconnect();
   exit 0;
}

$spool = "$spooldir/$server-$group";
$read = "$spool:read";

unless( safe_open( \*SPOOL, ">>$spool" ))
{
   feedback( "Could not open $spool for writing: $!\n" );
   disconnect();
   exit 1;
}

unless( safe_open( \*READ, ">>$read" ))
{
   feedback( "Could not open $read for writing: $!\n" );
   disconnect();
   exit 1;
}

$matches = 0;

foreach $key ( keys %results )
{
   print Peruser::SOCKET "article $key\r\n";
   $response = <Peruser::SOCKET>;

   $code = substr $response, 0, 3;
   next if ( $code ne "220" );

   ++$matches;

   do
   {
      $line = <Peruser::SOCKET>;
      print SPOOL $line;
   }
   while( $line ne ".\r\n" );

   print READ "u\n";
}

disconnect();

safe_close( \*READ );
safe_close( \*SPOOL );

kill 'USR1', $pid;

$response = "$matches articles downloaded from\\n$group";
feedback( $response );

0;
